#ifndef FILEPARSER_H_
#define FILEPARSER_H_

// Reads the full contents of "filename" into memory, malloc'ing space for
// its contents and returning a pointer to the allocated memory.  No special
// escaping/handling is provided if the file contains null (ie, zero-valued)
// bytes.
//
// Arguments:
// - filename:  a string containing the pathname of the file to read
// - size: if successful, an output parameter through which we return the size
//         of the file in bytes, assuming we successfully read it in.
//
// Returns:
// - NULL, if the read fails
// - Otherwise, the file's content.  This function will add '\0' to the end
//   of the file; however, the number of bytes returned through 'size' doesn't
//   include the final '\0'.  The caller is responsible for freeing the
//   returned pointer.
char* ReadFileToString(const char *filename, int *size);

#endif  // FILEPARSER_H_