#ifndef SERVER_UTIL_H_
#define SERVER_UTIL_H_

#include <cstring>
#include <string>

using namespace std;

static const int PATH_MAX = 254;

// Wrapper function around read that deals with reading errors.
// Read at most readlen bytes from fd and stores it into buf.
// on success it returns the number of bytes that
// have actually been read.
// on unrecoverable error, it returns -1.
// If EOF is hit and no bytes have been read, return 0.
int WrappedRead(int fd, string *buffer);

// Wrapper functions around write that deals with writing errors.
// Write at most writelen bytes into fd from buf.
// On success, it returns writelen number of bytes that
// have been successfully written.
// On failure, it will return a number that is less than
// writelen, this could be because of some unrecoverable error.
int WrappedWrite(int fd, unsigned char *buf, int writelen);

bool IsPathSafe(string rootdir, string testfile);

#endif  //SERVER_UTIL_H_