// Your code here...
import dslabs.framework.Message;
import dslabs.paxos.PaxosServer.BallotNumber;
import dslabs.paxos.PaxosServer.BallotValuePair;
import java.util.Map;
import lombok.Data;

@Data
class LeaderHeartbeat implements Message {
    private final Map<Integer, BallotValuePair> log;
    private final int garbageCollectUntil;
    private final BallotNumber ballotNumber;
}

@Data
class HeartbeatResponse implements Message {
    private final int lastExecutedSlot;
    private final BallotNumber highestBallotSeen;
}

@Data
class P1A implements Message {
    private final BallotNumber ballotNumber;
}

@Data
class P1B implements Message {
    private final BallotNumber acceptedBallot;
    private final Map<Integer, BallotValuePair> accepted;
}

@Data
class P2A implements Message {
    // Slot proposal
    private final BallotNumber ballot;
    private final int slotNum;
    private final PaxosRequest value;
}

@Data
class P2B implements Message {
    // Slot accepted
    private final BallotNumber ballot;
    private final int slotNum;
}
